<?php

// Setting the variables below to 1 activates each of the respective searches.
// The phonebook searches are executed in the order shown. 
// When a match is bound during a search, the callerid script ends with that result.
// E.g. if there is a match in AsteriDex, then the Google and AnyWho searches aren't executed.

$AsteriDex = '0';
$Canada411 = '0';
$Canada411B = '0';
$Find800Notes = '1';
$Google = '1';
$AnyWho = '1';



// ---------- Don't fiddle around below this line --------------------
//include ('browserfopen.php');
//$be = new BrowserEmulator(); 

$thenumber=$_REQUEST['thenumber'];
$thename=strtoupper($_REQUEST['thename']);
$detailed=$_REQUEST['detailed'];
$found = 0;

// strip non-numeric characters ().,-
$thenumber = preg_replace('/\D/','',$thenumber);
// check if leading 1 for long distance - strip if present
if (strlen($thenumber)==11):
  if (substr($thenumber,0,1) == '1'):
    $thenumber = substr($thenumber,1,10);
  endif;
endif;

// if not standard npanxxxxxx range, skip lookup
if (strlen($thenumber)<>10):
  exit;
endif;

$npa=substr($thenumber,0,3);
$nxx=substr($thenumber,3,3);
$xxxx=substr($thenumber,6,4);

if ($thename == 'O'):
  $thename = '';
endif;
if ($thename == 'P'):
  $thename = '';
endif;

if ($thename == 'PRIVATE NAME'):
  $thename = '';
endif;

if ($thename == 'PRIVATE'):
  $thename = '';
endif;

if ($thename == 'UNKNOWN'):
  $thename = '';
endif;

if ($thename == 'UNAVAILABLE'):
  $thename = '';
endif;

if ($thename == 'NOT FOUND'):
  $thename = '';
endif;

if ($thename == 'BLACKLISTED'):
  $thename = '';
endif;

$value="";

//*****************************************************************************
// look if in Asterisk database already
system('sudo /usr/sbin/asterisk -rx "database show "|grep cidname|grep '.$thenumber.' >/tmp/lastlookup');

$fd = fopen("/tmp/lastlookup", "r"); 
if (!$fd):
  echo "Asterisk db error"; 
else:
  $value = "";
  while(!feof($fd)){
    $value .= fread($fd, 4096);	
  }
  fclose($fd);
 
  $start= strpos($value, ":");

  $FNvalue = rtrim(substr($value,$start+2));

//$counter = 0;
//while($counter<strlen($FNvalue)) {
// echo ord(substr($FNvalue,$counter,1))." ".substr($FNvalue,$counter,1)." <br>";
// $counter = $counter + 1;
//}


  if (strlen($FNvalue)>2):
    $found = 1;
    if ($detailed==1):
      echo trim('Asterisk: '.$FNvalue.'<br>');
    else:
      echo $FNvalue.' ['.$thename.']';
      exit;
    endif;
  endif;
endif;

//*****************************************************************************
// not found...try AsteriDex
if ($AsteriDex=='1'):
  $link = mysql_connect("localhost", "root", "Desktop2004")
    or die("AsteriDex connection failed");
  mysql_select_db("asteridex")
    or die("AsteriDex data base open failed");
  $query = "SELECT * FROM user1 where out='$thenumber'";
  $result = mysql_query($query)
    or die("AsteriDex query failed");
  if (mysql_num_rows($result)>0):
    $row = mysql_fetch_array($result);
    $value=$row["name"];
  endif;
  mysql_close($link);
  if (strlen($value)>0):
    echo $value.' ['.$thename.']';
    exit;
  endif;
endif;

//*****************************************************************************
// not found  ... use localcallingguide.com to determine npa-nxx location and appropriate search directories
$fd = fopen("http://www.localcallingguide.com/lca_prefix.php?npa=$npa&nxx=$nxx", "r"); 
if (!$fd):
  echo "NPANXX Error"; 
  exit; 
endif;

$value = "";
while(!feof($fd)){
  $value .= fread($fd, 4096);	
}
fclose($fd);

// Get city/state info from local calling guide info
$start= strpos($value, "Local prefixes for "); 
$value = substr($value,$start+19);
$end=strpos($value, chr(34));
$valueCity = substr($value,0,$end);

// Get state/prov info from local calling guide info to map to country index
if ($valueCity == "IC "):
  $valueRegion = "NA";
else:
  $start= strpos($value, "Rate centres in "); 
  $valueRegion = substr($value,$start+16);
  $end=strpos($valueRegion, chr(34));
  $valueRegion = substr($valueRegion,0,$end);
endif;

switch ($valueRegion) {
  case "NA": $Country ="NA";break; // Not Applicable (800, 866, etc)
  case "AB": $Country ="Canada";break; // Alberta
  case "BC": $Country ="Canada";break; // British Columbia
  case "MB": $Country ="Canada";break; // Manitoba
  case "NB": $Country ="Canada";break; // New Brunswick
  case "NL": $Country ="Canada";break; // Newfoundland and Labrador
  case "NT": $Country ="Canada";break; // Northwest Territories
  case "NS": $Country ="Canada";break; // Nova Scotia
  case "NU": $Country ="Canada";break; // Nunavut
  case "ON": $Country ="Canada";break; // Ontario
  case "PE": $Country ="Canada";break; // Prince Edward Island
  case "QC": $Country ="Canada";break; // Quebec
  case "SK": $Country ="Canada";break; // Saskatchewan
  case "YT": $Country ="Canada";break; // Yukon
  case "AL": $Country ="USA";break; // Alabama
  case "AK": $Country ="USA";break; // Alaska
  case "AZ": $Country ="USA";break; // Arizona
  case "AR": $Country ="USA";break; // Arkansas
  case "CA": $Country ="USA";break; // California
  case "CO": $Country ="USA";break; // Colorado
  case "CT": $Country ="USA";break; // Connecticut
  case "DE": $Country ="USA";break; // Delaware
  case "DC": $Country ="USA";break; // District of Columbia
  case "FL": $Country ="USA";break; // Florida
  case "GA": $Country ="USA";break; // Georgia
  case "HI": $Country ="USA";break; // Hawaii
  case "ID": $Country ="USA";break; // Idaho
  case "IL": $Country ="USA";break; // Illinois
  case "IN": $Country ="USA";break; // Indiana
  case "IA": $Country ="USA";break; // Iowa
  case "KS": $Country ="USA";break; // Kansas
  case "KY": $Country ="USA";break; // Kentucky
  case "LA": $Country ="USA";break; // Louisiana
  case "ME": $Country ="USA";break; // Maine
  case "MD": $Country ="USA";break; // Maryland
  case "MA": $Country ="USA";break; // Massachusetts
  case "MI": $Country ="USA";break; // Michigan
  case "MN": $Country ="USA";break; // Minnesota
  case "MS": $Country ="USA";break; // Mississippi
  case "MO": $Country ="USA";break; // Missouri
  case "MT": $Country ="USA";break; // Montana
  case "NE": $Country ="USA";break; // Nebraska
  case "NV": $Country ="USA";break; // Nevada
  case "NH": $Country ="USA";break; // New Hampshire
  case "NJ": $Country ="USA";break; // New Jersey
  case "NM": $Country ="USA";break; // New Mexico
  case "NY": $Country ="USA";break; // New York
  case "NC": $Country ="USA";break; // North Carolina
  case "ND": $Country ="USA";break; // North Dakota
  case "OH": $Country ="USA";break; // Ohio
  case "OK": $Country ="USA";break; // Oklahoma
  case "OR": $Country ="USA";break; // Oregon
  case "PA": $Country ="USA";break; // Pennsylvania
  case "RI": $Country ="USA";break; // Rhode Island
  case "SC": $Country ="USA";break; // South Carolina
  case "SD": $Country ="USA";break; // South Dakota
  case "TN": $Country ="USA";break; // Tennessee
  case "TX": $Country ="USA";break; // Texas
  case "UT": $Country ="USA";break; // Utah
  case "VT": $Country ="USA";break; // Vermont
  case "VA": $Country ="USA";break; // Virginia
  case "WA": $Country ="USA";break; // Washington
  case "WV": $Country ="USA";break; // West Virginia
  case "WI": $Country ="USA";break; // Wisconsin
  case "WY": $Country ="USA";break; // Wyoming
  case "AI": $Country ="Caribbean";break; // Anguilla
  case "AN": $Country ="Caribbean";break; // Antigua and Barbuda
  case "BA": $Country ="Caribbean";break; // Bahamas
  case "BD": $Country ="Caribbean";break; // Barbados
  case "BM": $Country ="Caribbean";break; // Bermuda
  case "BV": $Country ="Caribbean";break; // British Virgin Islands
  case "CQ": $Country ="Caribbean";break; // Cayman Islands
  case "DM": $Country ="Caribbean";break; // Dominica
  case "DR": $Country ="Caribbean";break; // Dominican Republic
  case "GN": $Country ="Caribbean";break; // Grenada
  case "JM": $Country ="Caribbean";break; // Jamaica
  case "RT": $Country ="Caribbean";break; // Montserrat
  case "PR": $Country ="Caribbean";break; // Puerto Rico
  case "KA": $Country ="Caribbean";break; // St Kitts and Nevis
  case "SA": $Country ="Caribbean";break; // St Lucia
  case "ZF": $Country ="Caribbean";break; // St Vincent and the Grenadines
  case "TR": $Country ="Caribbean";break; // Trinidad and Tobago
  case "TC": $Country ="Caribbean";break; // Turks and Caicos
  case "VI": $Country ="Caribbean";break; // US Virgin Islands
  case "AS": $Country ="Pacific";break; // American Samoa
  case "GU": $Country ="Pacific";break; // Guam
  case "MP": $Country ="Pacific";break; // Northern Mariana Islands
}

if ($detailed==1):
  echo "Location: ".$valueCity.', '.$Country.'<br>';
endif;

if ($Country == "Canada"):
  // not found...try Canada411
  if ($Canada411=='1'):
    $fd = fopen("http://findaperson.canada-411.ca/14990/search/ReversePhone?phone=$thenumber", "r"); 
    // can change to "rb",  on NT/2000 servers, if problems.
    if (!$fd):
      echo "Canada411 Error"; 
    else:
      $value = "";
      while(!feof($fd)){
        $value .= fread($fd, 4096);	
      }
      fclose($fd); 
      $start= strpos($value, "cell phone");
      if ($start > 1):
        $value="Cellular Phone";
        echo $value;
        exit; 
      endif; 
      $start = strpos($value, "No results were found");
      if (!($start>0)) :
        // Get first name
        $start= strpos($value, "FIRST_ESC_=");
        $valueFN = substr($value,$start+11);
        $end=strpos($valueFN, "&_RM");
        $valueFN = substr($valueFN,0,$end); 
        // Get last name
        $start= strpos($value, "LAST_ESC_=");
        $valueLN = substr($value,$start+10);
        $end=strpos($valueLN, "&_RM");
        $valueLN = substr($valueLN,0,$end);
           
        // Don't know enough PHP to $value = last + ", " + first.  This works.
        $valueDisplay = $valueLN;
        $valueDisplay .= ", ";
        $valueDisplay .= $valueFN;
    
        $found = 1;
        if ($detailed == 1):
          // find printer friendly version of file - first link after Modify Search link
          $start = strpos($value, "Modify search");
          if ($start >0):
            //find and load link
            $value = substr($value,$start);
            $start = strpos($value, "<a href");
            $value = substr($value, $start + 10);
            $start = strpos($value, "/");
            $value = substr($value, $start );
            $end = strpos($value, chr(34));
            $value = substr($value, 0, $end);
            $fd = fopen(urldecode("http://www.whitepages.com/10001".$value), "r"); 
            $value = "";
            while(!feof($fd)){
              $value .= fread($fd, 4096);	
            }
            fclose($fd);
            $start = strpos($value, "Need More Help");
            $value = substr($value,$start);
            $start = strpos($value, "<h3>");
            $value = substr($value, $start );
            $end = strpos($value, "</div");
            $value = substr($value, 0, $end -1 );
            echo "*******************<br>";
            echo "Canada411 Home:<br>";
            echo $value."<br>";
            echo "*******************<br>";
          else:
            echo "Canada411 Home: ".$valueDisplay."<br>";
            if ($found == 0):
              $found = 0;
              system('/usr/sbin/calleridfix.sh  '.$thenumber.' "'.$valueDisplay.'">/dev/null '); 
            endif;
          endif;
        else: 
          if (strlen($value)>2):
            echo $valueDisplay.' ['.$thename.']';
            if ($found == 0):
              $found = 0;
              system('/usr/sbin/calleridfix.sh  '.$thenumber.' "'.$valueDisplay.'">/dev/null '); 
            endif;
            exit;
          endif;
        endif;
      endif;
    endif;
  endif;


  // not found so try Canada411 Business listings
  if ($Canada411B=='1'):
    $fd = fopen("http://canada411.yellowpages.ca/search/?src=&stype=re&pac=$npa&pex=$nxx&pnum=$xxxx", "r"); 
    if (!$fd):
      echo "Canada411B Error"; 
    else:
      $value = "";
      while(!feof($fd)){ 
        $value .= fread($fd, 16384);	
      }
      fclose($fd);
      
      if ($detailed==1) :
        echo "Canada411 Business<br>";
      endif;

      // Find start listing... 3 scenarios...not found, multiple or single entry...
      $start= strpos($value, "apologize");
      if (!($start>0)):
       $start= strpos($value, "WebNumber");
       if (($start>0)):
        $start= strpos($value, $npa."-".$nxx);
        if (($start>0)):
          $start= strpos($value, "multiple matches");
          if ($start>0):    //found a multiple match entry, otherwise single entry
            $value= substr($value,$start);
            $start= strpos($value, $npa. "-" .$nxx. "-" .$xxxx);
            $valuetmp= substr($value,$start);
            $start= strpos($valuetmp, "href");
            if (!($start>0)):
              $start= strpos($value, "HREF");
            endif;   
            $valuetmp2= substr($valuetmp,$start);
            $start= strpos($valuetmp2, ">");
            $valuetmp3= substr($valuetmp2,$start+1);
            $end=strpos($valuetmp3, "<");
            $value = substr($valuetmp3,0,$end);
            if (strlen($value)>2):
              echo $value.' ['.$thename.']';
              system('/usr/sbin/calleridfix.sh  '.$thenumber.' "'.$value.'">/dev/null '); 
              if ($found == 0):
                $found = 0;
                system('/usr/sbin/calleridfix.sh  '.$thenumber.' "'.$value.'">/dev/null '); 
              endif;
              exit;
            endif;
          endif;
        else:
          $start= strpos($value, "<H1>");
          if (!($start>0)):
            $start= strpos($value, "<h1>");
          endif;   
          $valuetmp= substr($value,$start+4);
          $end=strpos($valuetmp, "<");
          $value = substr($valuetmp,0,$end-1);
          if (strlen($value)>2):
            echo $value.' ['.$thename.']';
            system('/usr/sbin/calleridfix.sh  '.$thenumber.' "'.$value.'">/dev/null '); 
            if ($found == 0):
              $found = 0;
              system('/usr/sbin/calleridfix.sh  '.$thenumber.' "'.$value.'">/dev/null '); 
            endif;
            exit;
          endif;
        endif;
       endif;
      endif;
    endif;
  endif;
  if ($detailed==1) :
    echo "*******************<br>";
  endif;


endif;

include ('800notes.php');


if ($Country != "Canada"):
  if ($Google=='1'):
    $fd = fopen("http://www.google.com/search?rls=en&q=phonebook:$thenumber&ie=UTF-8&oe=UTF-8", "r"); // can change to "rb",  on NT/2000 servers, if problems.
    if (!$fd):
      echo "Google Error"; 
    else: 
      $value = "";
      while(!feof($fd)){
        $value .= fread($fd, 4096);	
      }
      fclose($fd);
      $start= strpos($value, "Phonebook</b>");
      $value = substr($value,$start+13);
      $start=strpos($value, "<tr bgcolor=#e5ecf9><td>");
      $value = substr($value,$start+24);
      $end=strpos($value, "<td>(");
      $value = substr($value,0,$end);
      if (strlen($value)>1):
        echo $value.' ['.$thename.']';
        system('/usr/sbin/calleridfix.sh  '.$thenumber.' "'.$value.'">/dev/null '); 
        exit;
      endif;
    endif;
  endif;
  if ($AnyWho=='1'):
    $npa=substr($thenumber,0,3);
    $telephone=substr($thenumber,3,7);
    $fd = fopen("http://www.anywho.com/qry/wp_rl?npa=$npa&telephone=$telephone", "r"); // can change to "rb",  on NT/2000 servers, if problems.
    if (!$fd):
      echo "AnyWho Error"; 
    else: 
      $value = "";
      while(!feof($fd)){ 
        $value .= fread($fd, 4096);	
      }
      fclose($fd);
      $start= strpos($value, "Reverse Telephone Listings</B>");
      $value = substr($value,$start+30);
      $start=strpos($value, "<B>");
      $value = substr($value,$start+3);
      $end=strpos($value, "</B>");
      $value = substr($value,0,$end);
      if ($value=="You searched for:"):
        $value="";
      endif;
      if (strlen($value)>1):
        echo $value.' ['.$thename.']';
        system('/usr/sbin/calleridfix.sh  '.$thenumber.' "'.$value.'">/dev/null '); 
        exit;
      endif;
    endif;
  endif;
endif;

// Not found - enter into database any Bell provided info
if (strlen($thename)>1):
      system('/usr/sbin/calleridfix.sh  '.$thenumber.' "'.$thename.'">/dev/null '); 
endif;


// not found so find city/prov(state) of npa
if (strlen($valueCity)>2):
  echo '['.$thename.']'.$valueCity.", ".$Country;
  exit;
endif;

$value="Unk";
echo $value.' ['.$thename.']';
exit;

?>

